require File.expand_path('../../helper', __FILE__)

describe Stow::Storable do
  subject { Class.new { include Stow::Storable } }

  describe Stow::Storable::ClassMethods do
    describe 'storage creates store' do
      it "with default options" do
        Stow.expects(:new).with(:adapter, {}).returns('the adapter')
        subject.storage :adapter
        assert_equal 'the adapter', subject.store
      end
      
      it "with custom options" do
        Stow.expects(:new).with(:adapter, { an: 'option' }).returns('the adapter')
        subject.storage :adapter, an: 'option'
        assert_equal 'the adapter', subject.store
      end
    end
    
    describe 'store accessor' do
      it "returns store" do
        subject.store = 'my store'
        assert_equal 'my store', subject.store
      end
    end
  end
end